local hcTk = HCToolkit

hcTk.FramesInit = function()
    HCToolkitGroupFrame = CreateFrame("Frame", "HCToolkitGroupFrame", UIParent);
    HCToolkitGroupFrame.MinHeight = 300
    HCToolkitGroupFrame.MinWidth = 200
    HCToolkitPersonalFrame = CreateFrame("Frame", "HCToolkitPersonalFrame", UIParent);
    HCToolkitPersonalFrame.MinHeight = 40
    HCToolkitPersonalFrame.MinWidth = 400

    hcTk.CreateFrame(HCToolkitGroupFrame, hcTk.DB.profile.Frames.Group)
    hcTk.CreateFrame(HCToolkitPersonalFrame, hcTk.DB.profile.Frames.Personal)
end

hcTk.CreateFrame = function(frame, settings)
    frame.DemoMode = false
    frame.texture = frame:CreateTexture(nil, "BACKGROUND")
    frame.font = frame:CreateFontString(nil, "OVERLAY")

    frame:SetScript("OnMouseDown", function(self, button)
        if settings.Unlocked and button == "LeftButton" and not self.isMoving then
        self:StartMoving();
        self.isMoving = true;
        end
    end)

    frame:SetScript("OnMouseUp", function(self, button)
        if button == "LeftButton" and self.isMoving then
        self:StopMovingOrSizing();
        self.isMoving = false;
        local point, relativeTo, relativePoint, xOffset, yOffset = frame:GetPoint(1);

        settings.Anchor = point;
        settings.X = xOffset;
        settings.Y = yOffset;
        end
    end)

    frame:SetScript("OnHide", function(self)
        if ( self.isMoving ) then
            self:StopMovingOrSizing();
            self.isMoving = false;
        end
    end)

    frame:SetHeight(frame.MinHeight)
    frame:SetWidth(frame.MinWidth)
    frame:SetPoint(settings.Anchor, settings.X, settings.Y)
    frame:SetMovable(settings.Unlocked)
    frame:EnableMouse(settings.Unlocked)

    frame.font:SetAllPoints(true)
    frame.font:SetJustifyH(settings.Text.Align)
    frame.font:SetJustifyV("TOP")
    frame.font:SetFont(hcTk.LSM:Fetch("font", settings.Text.Font), settings.Text.Size, settings.Text.Flag)
    frame.font:SetTextColor(1, 1, 1, 1)

    frame.texture:SetAllPoints(frame)
    frame.texture:SetTexture(0, 0, 0, 0)
end

hcTk.ResizeFrame = function(frame)
    local width = frame.font:GetStringWidth()
    if (width == nil or frame.MinWidth >= width) then
        width = frame.MinWidth
    end
    frame:SetWidth(width)
end

hcTk.FrameUpdateText = function(frame, text)
    frame.font:SetText(text)
    hcTk.ResizeFrame(frame)
end

hcTk.FrameDemoMode = function(frame, v)
    local text = ""

    if (v) then
        if (frame == HCToolkitGroupFrame) then
            text = text .. string.format("%s", "Maiden Intermission Assignments (Outer | Middle | Inner)\n")
            text = text .. string.format("|c%s%s:|r %s | %s | %s\n", "FF00FF00", "Fel Front", "Clutch", "Chaap", "Nastynelbur")
            text = text .. string.format("|c%s%s:|r %s | %s | %s\n", "FF00FF00", "Fel Back", "Auro", "Jetshunter", "Tenkiei")
            text = text .. string.format("|c%s%s:|r %s | %s | %s\n", "FFFFDF00", "Holy Front", "Ugly", "Nightsdh", "Buddie")
            text = text .. string.format("|c%s%s:|r %s | %s | %s\n", "FFFFDF00", "Holy Back", "Partyrawk", "Skyline", "Procz")
        elseif (frame == HCToolkitPersonalFrame) then
            -- text = string.format("|c%s%s|r", "FFFFDF00", "INNER - FRONT")
            text = string.format("|c%s%s|r", "FF00FF00", "OUTER - BACK")
        end
    end

    frame.DemoMode = v
    hcTk.FrameUpdateText(frame, text)
end